Index: LMDZ6/branches/IPSLCM6.0.15/DefLists/CMIP6_ping_aerosol_lmdz.xml
===================================================================
--- LMDZ6/branches/IPSLCM6.0.15/DefLists/CMIP6_ping_aerosol_lmdz.xml	(revision 3485)
+++ LMDZ6/branches/IPSLCM6.0.15/DefLists/CMIP6_ping_aerosol_lmdz.xml	(revision 3510)
@@ -88,15 +88,15 @@
    <field id="CMIP6_minpblz"       field_ref="dummy_XY"         /> <!-- P1 (m) atmosphere_boundary_layer_thickness : minimum boundary layer height during the day (add cell_methods attribute: "time: minimum") -->
    <field id="CMIP6_mmraerh2o"     field_ref="dummy_XYA"        /> <!-- P1 (kg kg-1) mass_fraction_of_water_in_ambient_aerosol_particles_in_air : Aerosol water mass mixing ratio -->
-   <field id="CMIP6_mmrbc"         field_ref="dummy_XYA"        /> <!-- P1 (kg kg-1) mass_fraction_of_elemental_carbon_dry_aerosol_particles_in_air : Elemental carbon mass mixing ratio -->
-   <field id="CMIP6_mmrdust"       field_ref="dummy_XYA"        /> <!-- P1 (kg kg-1) mass_fraction_of_dust_dry_aerosol_particles_in_air : Dust aerosol mass mixing ratio -->
+   <field id="CMIP6_mmrbc"         field_ref="concbc"   > concbc/pres*temp*287.05967366659070 </field> <!-- P1 (kg kg-1) mass_fraction_of_elemental_carbon_dry_aerosol_particles_in_air : Elemental carbon mass mixing ratio -->
+   <field id="CMIP6_mmrdust"       field_ref="concdust" > concdust/pres*temp*287.05967366659070 </field> <!-- P1 (kg kg-1) mass_fraction_of_dust_dry_aerosol_particles_in_air : Dust aerosol mass mixing ratio -->
    <field id="CMIP6_mmrnh4"        field_ref="dummy_XYA"        /> <!-- P1 (kg kg-1) mass_fraction_of_ammonium_dry_aerosol_particles_in_air : NH4 mass mixing ratio -->
-   <field id="CMIP6_mmrno3"        field_ref="dummy_XYA"        /> <!-- P1 (kg kg-1) mass_fraction_of_nitrate_dry_aerosol_particles_in_air : NO3 aerosol mass mixing ratio -->
-   <field id="CMIP6_mmroa"         field_ref="dummy_XYA"        /> <!-- P1 (kg kg-1) mass_fraction_of_particulate_organic_matter_dry_aerosol_particles_in_air : We recommend a scale factor of POM=1.4*OC, unless your model has more detailed info available. -->
+   <field id="CMIP6_mmrno3"        field_ref="concno3"  > concno3/pres*temp*287.05967366659070 </field> <!-- P1 (kg kg-1) mass_fraction_of_nitrate_dry_aerosol_particles_in_air : NO3 aerosol mass mixing ratio -->
+   <field id="CMIP6_mmroa"         field_ref="concoa"   > concoa/pres*temp*287.05967366659070 </field> <!-- P1 (kg kg-1) mass_fraction_of_particulate_organic_matter_dry_aerosol_particles_in_air : We recommend a scale factor of POM=1.4*OC, unless your model has more detailed info available. -->
    <field id="CMIP6_mmrpm1"        field_ref="dummy_XYA"        /> <!-- P1 (kg kg-1) mass_fraction_of_pm1_dry_aerosol_particles_in_air : E.g. mass_fraction_of_pm1_aerosol_at_50_percent_relative_humidity_in_air. proposed name:  mass_fraction_of_pm1_dry_aerosol_in_air -->
    <field id="CMIP6_mmrpm10"       field_ref="dummy_XYA"        /> <!-- P1 (kg kg-1) mass_fraction_of_pm10_ambient_aerosol_particles_in_air : E.g. mass_fraction_of_pm10_aerosol_at_50_percent_relative_humidity_in_air, proposed name: mass_fraction_of_pm10_dry_aerosol_in_air -->
    <field id="CMIP6_mmrpm2p5"      field_ref="dummy_XYA"        /> <!-- P1 (kg kg-1) mass_fraction_of_pm2p5_dry_aerosol_particles_in_air : E.g. mass_fraction_of_pm2p5_aerosol_at_50_percent_relative_humidity_in_air, proposed_name: mass_fraction_of_pm2p5_dry_aerosol_in_air -->
-   <field id="CMIP6_mmrso4"        field_ref="dummy_XYA"        /> <!-- P1 (kg kg-1) mass_fraction_of_sulfate_dry_aerosol_particles_in_air : Aerosol sulfate mass mixing ratio -->
+   <field id="CMIP6_mmrso4"        field_ref="concso4"  > concso4/pres*temp*287.05967366659070 </field> <!-- P1 (kg kg-1) mass_fraction_of_sulfate_dry_aerosol_particles_in_air : Aerosol sulfate mass mixing ratio -->
    <field id="CMIP6_mmrsoa"        field_ref="dummy_XYA"        /> <!-- P1 (kg kg-1) mass_fraction_of_secondary_particulate_organic_matter_dry_aerosol_particles_in_air : Secondary organic aerosol mass mixing ratio -->
-   <field id="CMIP6_mmrss"         field_ref="dummy_XYA"        /> <!-- P1 (kg kg-1) mass_fraction_of_seasalt_dry_aerosol_particles_in_air : Sea Salt mass mixing ratio -->
+   <field id="CMIP6_mmrss"         field_ref="concss"   > concss/pres*temp*287.05967366659070 </field> <!-- P1 (kg kg-1) mass_fraction_of_seasalt_dry_aerosol_particles_in_air : Sea Salt mass mixing ratio -->
    <field id="CMIP6_nh50"          field_ref="dummy_XYA"        /> <!-- P1 (mol mol-1) mole_fraction_of_artificial_tracer_with_fixed_lifetime_in_air : Fixed surface layer mixing ratio over 30o-50oN (100ppbv), uniform fixed 50-day exponential decay. -->
    <field id="CMIP6_no"            field_ref="dummy_XYA"        /> <!-- P1 (mol mol-1) mole_fraction_of_nitrogen_monoxide_in_air : NO volume mixing ratio -->