Index: LMDZ6/branches/IPSLCM6.0.15/libf/phylmd/StratAer/traccoag_mod.F90
===================================================================
--- LMDZ6/branches/IPSLCM6.0.15/libf/phylmd/StratAer/traccoag_mod.F90	(revision 3525)
+++ LMDZ6/branches/IPSLCM6.0.15/libf/phylmd/StratAer/traccoag_mod.F90	(revision 3529)
@@ -59,5 +59,4 @@
 !----------------
     REAL                                   :: m_aer_emiss_vol_daily ! daily injection mass emission
-    REAL                                   :: sum_emi_so2         ! Test sum of all LON for budg_emi_so2
     INTEGER                                :: it, k, i, ilon, ilev, itime, i_int, ieru
     LOGICAL,DIMENSION(klon,klev)           :: is_strato           ! true = above tropopause, false = below
@@ -84,37 +83,4 @@
        WRITE(lunout,*) 'in traccoag: date from phys_cal_mod =',year_cur,'-',mth_cur,'-',day_cur,'-',hour
        WRITE(lunout,*) 'IN traccoag flag_sulf_emit: ',flag_sulf_emit
-       IF (flag_sulf_emit == 1) THEN
-          WRITE(lunout,*) 'IN traccoag nErupt: ',nErupt
-          WRITE(lunout,*) 'IN traccoag injdur: ',injdur
-          WRITE(lunout,*) 'IN traccoag : year_emit_vol',year_emit_vol
-          WRITE(lunout,*) 'IN traccoag : mth_emit_vol',mth_emit_vol
-          WRITE(lunout,*) 'IN traccoag : day_emit_vol',day_emit_vol
-          WRITE(lunout,*) 'IN traccoag : m_aer_emiss_vol',m_aer_emiss_vol
-          WRITE(lunout,*) 'IN traccoag : altemiss_vol',altemiss_vol
-          WRITE(lunout,*) 'IN traccoag : sigma_alt_vol',sigma_alt_vol
-          WRITE(lunout,*) 'IN traccoag : ponde_lonlat_vol',ponde_lonlat_vol
-          WRITE(lunout,*) 'IN traccoag : xlat_min_vol',xlat_min_vol
-          WRITE(lunout,*) 'IN traccoag : xlat_max_vol',xlat_max_vol
-          WRITE(lunout,*) 'IN traccoag : xlon_min_vol',xlon_min_vol
-          WRITE(lunout,*) 'IN traccoag : xlon_max_vol',xlon_max_vol
-       ELSEIF (flag_sulf_emit == 2) THEN
-          WRITE(lunout,*) 'IN traccoag : m_aer_emiss_sai',m_aer_emiss_sai
-          WRITE(lunout,*) 'IN traccoag : altemiss_sai',altemiss_sai
-          WRITE(lunout,*) 'IN traccoag : sigma_alt_sai',sigma_alt_sai
-          WRITE(lunout,*) 'IN traccoag : xlat_sai',xlat_sai
-          WRITE(lunout,*) 'IN traccoag : xlon_sai',xlon_sai
-       ELSEIF (flag_sulf_emit == 3) THEN
-          WRITE(lunout,*) 'IN traccoag : m_aer_emiss_sai',m_aer_emiss_sai
-          WRITE(lunout,*) 'IN traccoag : altemiss_sai',altemiss_sai
-          WRITE(lunout,*) 'IN traccoag : sigma_alt_sai',sigma_alt_sai
-          WRITE(lunout,*) 'IN traccoag : xlat_min_sai',xlat_min_sai
-          WRITE(lunout,*) 'IN traccoag : xlat_max_sai',xlat_max_sai
-          WRITE(lunout,*) 'IN traccoag : xlon_sai',xlon_sai
-       ENDIF
-       WRITE(lunout,*) 'IN traccoag : flag_nuc_rate_box = ',flag_nuc_rate_box
-       IF (flag_nuc_rate_box) THEN
-          WRITE(lunout,*) 'IN traccoag : nuclat_min = ',nuclat_min,', nuclat_max = ',nuclat_max
-          WRITE(lunout,*) 'IN traccoag : nucpres_min = ',nucpres_min,', nucpres_max = ',nucpres_max
-       ENDIF
     ENDIF
     
@@ -190,7 +156,4 @@
       ! stretch emission over one day of Pinatubo eruption
        DO ieru=1, nErupt
-          IF (is_mpi_root) THEN
-             sum_emi_so2 = 0.0 ! Init sum
-          ENDIF
           IF (year_cur==year_emit_vol(ieru).AND.mth_cur==mth_emit_vol(ieru).AND.&
                day_cur>=day_emit_vol(ieru).AND.day_cur<(day_emit_vol(ieru)+injdur)) THEN
@@ -201,9 +164,7 @@
                   'ponde_lonlat_vol(ieru)=',ponde_lonlat_vol(ieru),'(injdur*ponde_lonlat_vol(ieru))', &
                   (injdur*ponde_lonlat_vol(ieru)),'m_aer_emiss_vol_daily=',m_aer_emiss_vol_daily,'ieru=',ieru
-             WRITE(lunout,*) 'IN traccoag, dlon=',dlon
              DO i=1,klon
                 !Pinatubo eruption at 15.14N, 120.35E
                 dlat_loc=180./RPI/2.*(boundslat(i,1)-boundslat(i,3)) ! dlat = half difference of boundary latitudes
-                WRITE(lunout,*) 'IN traccoag, dlat=',dlat_loc
                 IF ( xlat(i).GE.xlat_min_vol(ieru)-dlat_loc .AND. xlat(i).LT.xlat_max_vol(ieru)+dlat_loc .AND. &
                      xlon(i).GE.xlon_min_vol(ieru)-dlon .AND. xlon(i).LT.xlon_max_vol(ieru)+dlon ) THEN
@@ -259,8 +220,6 @@
                       budg_emi_so2(i)=budg_emi_so2(i)+emission*zdm(k)*mSatom/mSO2mol
                    ENDDO
-                   sum_emi_so2 = sum_emi_so2 + budg_emi_so2(i) ! Sum all LON
                 ENDIF ! emission grid cell
              ENDDO ! klon loop
-             WRITE(lunout,*) "IN traccoag (ieru=",ieru,") global sum_emi_so2=",sum_emi_so2
              WRITE(lunout,*) "IN traccoag (ieru=",ieru,") m_aer_emiss_vol_daily=",m_aer_emiss_vol_daily
           ENDIF ! emission period
@@ -274,10 +233,7 @@
 !       SAI continuous emission o
         dlat_loc=180./RPI/2.*(boundslat(i,1)-boundslat(i,3)) ! dlat = half difference of boundary latitudes
-        WRITE(lunout,*) "IN traccoag, dlon=",dlon
-        WRITE(lunout,*) "IN traccoag, dlat=",dlat_loc
         IF  ( xlat(i).GE.xlat_sai-dlat_loc .AND. xlat(i).LT.xlat_sai+dlat_loc .AND. &
           &   xlon(i).GE.xlon_sai-dlon .AND. xlon(i).LT.xlon_sai+dlon ) THEN
 !
-          WRITE(lunout,*) 'coordinates of SAI point=',xlat(i), xlon(i), day_cur, mth_cur, year_cur
 !         compute altLMDz
           altLMDz(:)=0.0
@@ -346,5 +302,4 @@
 !       SAI scenario with continuous emission
         dlat_loc=180./RPI/2.*(boundslat(i,1)-boundslat(i,3)) ! dlat = half difference of boundary latitudes
-        WRITE(lunout,*) 'IN traccoag, dlat = ',dlat_loc
         theta_min = max(xlat(i)-dlat_loc,xlat_min_sai)
         theta_max = min(xlat(i)+dlat_loc,xlat_max_sai)